
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Host.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::matahari;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Host::packageName  = string ("com.redhat.matahari");
string  Host::className    = string ("host");
uint8_t Host::md5Sum[MD5_LEN]   =
    {0x72,0x97,0xd9,0xc,0x5e,0x2a,0x55,0x7c,0x7b,0x58,0x90,0xcd,0xd4,0xd9,0x16,0xf2};

Host::Host (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    uuid = "";
    hostname = "";
    is_virtual = 0;
    operating_system = "";
    memory = 0;
    swap = 0;
    arch = "";
    hypervisor = "";
    platform = 0;
    processors = 0;
    cores = 0;
    model = "";
    last_updated_seq = 0;
    last_updated = 0;
    load_average_1 = 0.;
    load_average_5 = 0.;
    load_average_15 = 0.;
    memFree = 0;
    swapFree = 0;
    procTotal = 0;
    procRunning = 0;



}

Host::~Host ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Host::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Host::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (12); // Config Element Count
    buf.putShort       (9); // Inst Element Count
    buf.putShort       (3); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "uuid";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Host UUID";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "hostname";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Hostname";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "is_virtual";
    ft[TYPE] = TYPE_BOOL;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Is this machine virtual?";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "operating_system";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The installed operating system.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "memory";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "kb";
    ft[DESC] = "Amount of primary memory for host (kb)";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "swap";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "kb";
    ft[DESC] = "Amount of swap for host (kb)";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "arch";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Architecture of host";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "hypervisor";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Hypervisor used by host";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "platform";
    ft[TYPE] = TYPE_U8;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "bit";
    ft[DESC] = "The wordsize for the host.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "processors";
    ft[TYPE] = TYPE_U8;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The number of physical CPUs.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cores";
    ft[TYPE] = TYPE_U8;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The total number of processor cores.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "model";
    ft[TYPE] = TYPE_LSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The processor(s) model description.";
    buf.putMap(ft);


    // Statistics
    ft.clear();
    ft[NAME] = "last_updated_seq";
    ft[TYPE] = TYPE_U32;
    ft[DESC] = "The heartbeat sequence number.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "last_updated";
    ft[TYPE] = TYPE_ABSTIME;
    ft[DESC] = "The last time a heartbeat occurred.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "load_average_1";
    ft[TYPE] = TYPE_DOUBLE;
    ft[DESC] = "The one minute load average.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "load_average_5";
    ft[TYPE] = TYPE_DOUBLE;
    ft[DESC] = "The five minute load average.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "load_average_15";
    ft[TYPE] = TYPE_DOUBLE;
    ft[DESC] = "The fiften minute load average";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "memFree";
    ft[TYPE] = TYPE_U32;
    ft[DESC] = "Amount of available memory for host (kb)";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "swapFree";
    ft[TYPE] = TYPE_U32;
    ft[DESC] = "Amount of available swap for host (kb)";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "procTotal";
    ft[TYPE] = TYPE_U32;
    ft[DESC] = "Total processes";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "procRunning";
    ft[TYPE] = TYPE_U32;
    ft[DESC] = "Total running processes";
    buf.putMap(ft);


    // Methods
    ft.clear();
    ft[NAME] =  "identify";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Tells the host to beep its pc speaker.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "shutdown";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Shutdown node";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "reboot";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Reboot node";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string Host::getKey() const
{
    std::stringstream key;

    key << uuid;
    return key.str();
}



void Host::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["uuid"] = ::qpid::types::Variant(uuid);
    _map["hostname"] = ::qpid::types::Variant(hostname);
    _map["is_virtual"] = ::qpid::types::Variant(is_virtual);
    _map["operating_system"] = ::qpid::types::Variant(operating_system);
    _map["memory"] = ::qpid::types::Variant(memory);
    _map["swap"] = ::qpid::types::Variant(swap);
    _map["arch"] = ::qpid::types::Variant(arch);
    _map["hypervisor"] = ::qpid::types::Variant(hypervisor);
    _map["platform"] = ::qpid::types::Variant(platform);
    _map["processors"] = ::qpid::types::Variant(processors);
    _map["cores"] = ::qpid::types::Variant(cores);
    _map["model"] = ::qpid::types::Variant(model);

    }

    if (includeStatistics) {
        instChanged = false;




    _map["last_updated_seq"] = ::qpid::types::Variant(last_updated_seq);
    _map["last_updated"] = ::qpid::types::Variant(last_updated);
    _map["load_average_1"] = ::qpid::types::Variant(load_average_1);
    _map["load_average_5"] = ::qpid::types::Variant(load_average_5);
    _map["load_average_15"] = ::qpid::types::Variant(load_average_15);
    _map["memFree"] = ::qpid::types::Variant(memFree);
    _map["swapFree"] = ::qpid::types::Variant(swapFree);
    _map["procTotal"] = ::qpid::types::Variant(procTotal);
    _map["procRunning"] = ::qpid::types::Variant(procRunning);


    // Maintenance of hi-lo statistics


    }
}

void Host::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("uuid")) != _map.end()) {
        uuid = (_i->second).getString();
    }
    if ((_i = _map.find("hostname")) != _map.end()) {
        hostname = (_i->second).getString();
    }
    if ((_i = _map.find("is_virtual")) != _map.end()) {
        is_virtual = _i->second;
    }
    if ((_i = _map.find("operating_system")) != _map.end()) {
        operating_system = (_i->second).getString();
    }
    if ((_i = _map.find("memory")) != _map.end()) {
        memory = _i->second;
    }
    if ((_i = _map.find("swap")) != _map.end()) {
        swap = _i->second;
    }
    if ((_i = _map.find("arch")) != _map.end()) {
        arch = (_i->second).getString();
    }
    if ((_i = _map.find("hypervisor")) != _map.end()) {
        hypervisor = (_i->second).getString();
    }
    if ((_i = _map.find("platform")) != _map.end()) {
        platform = _i->second;
    }
    if ((_i = _map.find("processors")) != _map.end()) {
        processors = _i->second;
    }
    if ((_i = _map.find("cores")) != _map.end()) {
        cores = _i->second;
    }
    if ((_i = _map.find("model")) != _map.end()) {
        model = (_i->second).getString();
    }

}

void Host::doMethod (string& methodName, const ::qpid::types::Variant::Map&, ::qpid::types::Variant::Map& outMap)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "identify") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_IDENTIFY, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "shutdown") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_SHUTDOWN, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "reboot") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_REBOOT, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
